
	function getCookie(c_name) {
		var i, x, y, ARRcookies = document.cookie.split(";");
		for (i = 0; i < ARRcookies.length; i++) {
			x = ARRcookies[i].substr(0, ARRcookies[i].indexOf("="));
			y = ARRcookies[i].substr(ARRcookies[i].indexOf("=") + 1);
			x = x.replace(/^\s+|\s+$/g, "");
			if (x == c_name) {
				return unescape(y);
			}
		}
	}

	function setCookie(c_name, value, exdays) {
		var exdate = new Date();
		exdate.setDate(exdate.getDate() + exdays);
		var c_value = escape(value) + ((exdays == null) ? "" : "; expires=" + exdate.toUTCString());
		document.cookie = c_name + "=" + c_value;
	}
	
	function verify_Html5FileApi_IsSupported()
	{
		if (window.File && window.FileReader && window.FileList && window.Blob) 
			return true;
		else
			return false;
	}
	
	function verify_FileSelection_IsValid(inputFile)
	{
		if (!inputFile) 
		{
			alert(ui.translations['error_file_not_found']);
		}
		else if (!inputFile.files) 
		{
			alert(ui.translations['error_browser_not_supported']);
		}
		else if (!inputFile.files[0]) 
		{
			alert(ui.translations['ask_select_file']);
		}
		else 
		{
			return true;
		}
							
		return false;
	}
	
	function hideOverlay(overlayContentId) {
		var o = document.getElementById('overlay');
		o.style.visibility = 'hidden';
		$('#' + overlayContentId).css("display","none");
	}
		
	function showOverlay(overlayContentId) {
		var o = document.getElementById('overlay');
		o.style.visibility = 'visible';
		$('#' + overlayContentId).css("display","inline");
		$('#' + overlayContentId).center();
	}
	
	function progressBar_Show(divID)
	{
		$('#' + divID).append('<div id="progress_bar"><div class="percent" >0%</div></div>'); 
		$(".percent").css("width", "0%");
		$(".percent").text("0%");
		document.getElementById('progress_bar').className = 'loading';
	}
	
	function progressBar_Hide()
	{
		document.getElementById('progress_bar').className='';
		//setTimeout("$('#progress_bar').remove(); ", 1250);
		$('#progress_bar').remove();
	}
	
	function progressBar_update( nbOfPostSent, totalNbOfPost) 
	{
		var percentLoaded = Math.round((nbOfPostSent / totalNbOfPost) * 100);
		// Increase the progress bar length.
		if (percentLoaded < 100) {
			$(".percent").css("width", percentLoaded + "%");
			$(".percent").text(percentLoaded + "%");
		}
	}		
	
	function progressBar_Display100percent()
	{
		$(".percent").css("width", "100%");
		$(".percent").text("100%");
	}
	
	function fakeProgressBar_update( durationInMs, callbackAtTheEnd) 
	{
		var nbOfInterval = durationInMs / 100;
		
		progressBar_update( fakeProgressBar_update.counter, 100);
		fakeProgressBar_update.counter++;
			
		if(fakeProgressBar_update.counter < 101)
		{
			setTimeout( function(){
				fakeProgressBar_update(durationInMs, callbackAtTheEnd);
			}, nbOfInterval);
		}
		else
		{
			progressBar_Display100percent();
			
			if (callbackAtTheEnd) 
				callbackAtTheEnd();
				
			fakeProgressBar_Hide();
			setTimeout("hideOverlay();", 1500);
			fakeProgressBar_update.counter = 0;
		}
	}		
	fakeProgressBar_update.counter = 0;	
	
	function fakeProgressBar_Launch(divID, durationInMs, callbackAtTheEnd)
	{
		progressBar_Show(divID);
		
		fakeProgressBar_update( durationInMs, callbackAtTheEnd);
	}
		
	function fakeProgressBar_Hide()
	{
		progressBar_Hide(); 
	}
	
	function isFloat(val) {
	    if(!val || (typeof val != "string" || val.constructor != String)) {
		          return(false);
		             }
            var isNumber = !isNaN(new Number(val));
            if(isNumber) {
                     if(val.indexOf('.') != -1) {
                            return(true);
                      } else {
                                 return(false);
                       }
            } else {
                  return(false);
              }
	}

	function is_Int_Or_Float(value){ 

		if (value == "" )
			return false;

	  if((parseFloat(value) == parseInt(value)) && !isNaN(value)){
	       return true;
	   } else {
		   return isFloat(value);
	   } 
	}

	function is_int(value){ 

		if (value == "" )
			return false;

		if((parseFloat(value) == parseInt(value)) && !isNaN(value)){
	       return true;
		} else { 
	      return false;
		} 
	}
	
	function decimalToHex(d, padding) 
	{
	    var hex = Number(d).toString(16);
	    padding = typeof (padding) === "undefined" || padding === null ? padding = 2 : padding;

	    while (hex.length < padding) {
	        hex = "0" + hex;
	    }

	    return hex.toUpperCase();
	}	
	
	function paddingBefore(stringToPad, paddingCharacter, paddingSize)
	{
		var paddedValue = stringToPad;
		
		while (paddedValue.length < paddingSize) 
		{
			paddedValue = paddingCharacter + paddedValue;
	    }
		
		return paddedValue;
	}
	
	function is_int_positive(value){ 

		if (!is_int(value))
			return false;

		if(parseInt(value) < 0){
	       return false;
		} else { 
	      return true;
		} 
	}
	
	$(function() {
			
		$.fn.center = function() {
			this.css({
			'position': 'fixed',
			'left': '50%',
			'top': '50%'
			});
			this.css({
			'margin-left': -this.outerWidth() / 2 + 'px',
			'margin-top': -this.outerHeight() / 2 + 'px'
			});
			return this;
		};
		
	    var ConvertBase = function (num) {
	        return {
	            from : function (baseFrom) {
	                return {
	                    to : function (baseTo) {
	                        return parseInt(num, baseFrom).toString(baseTo);
	                    }
	                };
	            }
	        };
	    };
	        
	    // binary to decimal
	    ConvertBase.bin2dec = function (num) {
	        return ConvertBase(num).from(2).to(10);
	    };
	    
	    // binary to hexadecimal
	    ConvertBase.bin2hex = function (num) {
	        return ConvertBase(num).from(2).to(16);
	    };
	    
	    // decimal to binary
	    ConvertBase.dec2bin = function (num) {
	        return ConvertBase(num).from(10).to(2);
	    };
	    
	    // decimal to hexadecimal
	    ConvertBase.dec2hex = function (num) {
	        return ConvertBase(num).from(10).to(16);
	    };
	    
	    // hexadecimal to binary
	    ConvertBase.hex2bin = function (num) {
	        return ConvertBase(num).from(16).to(2);
	    };
	    
	    // hexadecimal to decimal
	    ConvertBase.hex2dec = function (num) {
	        return ConvertBase(num).from(16).to(10);
	    };
	    
	    this.ConvertBase = ConvertBase;
	    
	    /*
	    * Usage example:
	    * ConvertBase.bin2dec('111'); // '7'
	    * ConvertBase.dec2hex('42'); // '2a'
	    * ConvertBase.hex2bin('f8'); // '11111000'
	    * ConvertBase.dec2bin('22'); // '10110'
	    */
		
	});
	
	function postRegular(command, data, callback, errorCallback) {
		$.ajax({
			type: 'POST',
			url: baseURL + command + '?sid=' + this.getSessionId,
			data: data,
			timeout: 10000,
			success: function(data) {
				if (callback) callback(data);
			},
			error: function(xhr) {
				if (errorCallback) errorCallback(xhr);
				else{
					//manageGenericPostError(xhr);
				}
			}
		});
	};

	function postJson(theUrl, data, callback, errorCallback) {
		$.ajax({
			type: 'POST',
			url: '/mnc' + theUrl,
			contentType : 'application/json',
			data: JSON.stringify(data),
			dataType: 'json',
			timeout: 10000,
			success: function(data) {
				if (callback) callback(data);
			},
			error: function(xhr) {
				if (errorCallback) 
					errorCallback(xhr);
				else{
					//manageGenericPostError(xhr);
				}
			}
		});
	};
	
	function postJsonT(theUrl, data, timeOutInMsec, callback, errorCallback) {
		$.ajax({
			type: 'POST',
			url: '/mnc' + theUrl,
			contentType : 'application/json',
			data: JSON.stringify(data),
			dataType: 'json',
			timeout: timeOutInMsec,
			success: function(data) {
				if (callback) callback(data);
			},
			error: function(xhr) {
				if (errorCallback) 
					errorCallback(xhr);
				else{
					//manageGenericPostError(xhr);
				}
			}
		});
	};
	
	function getJson(theUrl, data, callback, errorCallback) {
		$.ajax({
			type: 'GET',
			url: '/mnc' + theUrl,
			contentType : 'application/json',
			data: JSON.stringify(data),
			dataType: 'json',
			timeout: 10000,
			success: function(data) {
				if (callback) callback(data);
			},
			error: function(xhr) {
				if (errorCallback) 
					errorCallback(xhr);
				else{
					//manageGenericPostError(xhr);
				}
			}
		});
	};
	
	function isDuplicate(arrayOfObj, isArraySequential, keyToFind, valueToFind) {
		
		var occurence = 0;
		
		if(isArraySequential)
		{
			for(var i=0; i<arrayOfObj.length; i++)
			{
				var currObj = arrayOfObj[i];
	    	
				if( currObj[keyToFind] == valueToFind )
					occurence++;
			}
		}
		else
		{
			for (key in arrayOfObj) 
			{
				var currObj = arrayOfObj[key];
		    	
				if( currObj[keyToFind] == valueToFind )
					occurence++;
			}
		}

	    if(occurence >1)
	    	return true;
	    else
	    	return false;
	}

	var makeCRCTable = function(){
	    var c;
	    var crcTable = [];
	    for(var n =0; n < 256; n++){
	        c = n;
	        for(var k =0; k < 8; k++){
	            c = ((c&1) ? (0xEDB88320 ^ (c >>> 1)) : (c >>> 1));
	        }
	        crcTable[n] = c;
	    }
	    return crcTable;
	}

	var crc32 = function(str) {
	    var crcTable = window.crcTable || (window.crcTable = makeCRCTable());
	    var crc = 0 ^ (-1);

	    for (var i = 0; i < str.length; i++ ) {
	        crc = (crc >>> 8) ^ crcTable[(crc ^ str.charCodeAt(i)) & 0xFF];
	    }

	    return (crc ^ (-1)) >>> 0;
	};
